=== debian/changelog ===
pulseview (0.4.1-1build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 21:23:30 +0000

pulseview (0.4.1-1) unstable; urgency=medium

  * New upstream release.
    + Remove GCC 8 patch now included upstream.
    + Update debian/copyright.
  * Standards-Version: 4.2.1
    + Set Rules-Requires-Root to no.

 -- Jonathan McDowell <noodles@earth.li>  Sun, 04 Nov 2018 10:40:50 +0000
