=== debian/control ===
Source: pulseview
Section: electronics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Electronics Packaging Team <pkg-electronics-devel@alioth-lists.debian.net>
Uploaders: Jonathan McDowell <noodles@earth.li>
Build-Depends: debhelper (>= 10), cmake (>= 2.8.6), pkg-config (>= 0.22),
 libglib2.0-dev (>= 2.28.0), libboost-system-dev, libboost-thread-dev,
 libboost-filesystem-dev, libboost-test-dev, libsigrokcxx-dev (>= 0.5.0),
 libsigrokdecode-dev (>= 0.5.0), libglibmm-2.4-dev (>= 2.28.0),
 qtbase5-dev, qtbase5-dev-tools, libqt5svg5-dev,
 libsigc++-2.0-dev (>= 2.10.0-2.1)
Standards-Version: 4.2.1
Rules-Requires-Root: no
Homepage: http://sigrok.org/wiki/PulseView
Vcs-Browser: https://salsa.debian.org/electronics-team/sigrok/pulseview
Vcs-Git: https://salsa.debian.org/electronics-team/sigrok/pulseview.git

Package: pulseview
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: sigrok logic analyzer, oscilloscope, and MSO GUI
 PulseView is a GUI for sigrok that supports logic analyzers, oscilloscopes,
 and MSOs.
 .
 It can acquire samples from a supported device and display them,
 load and display captures from existing sigrok *.sr files, as well
 as run protocol decoders and display their annotations.
