## pulseview 0.4.1.1%2Brb2

=== debian/changelog ===
pulseview (0.4.1.1+rb2-1+eagle) unstable; urgency=medium

  * update

 -- Debian Electronics Packaging Team <pkg-electronics-devel@alioth-lists.debian.net>  Fri, 29 Jan 2021 09:22:14 +0800
