=== test/CMakeLists.txt ===
--- 
+++ 
@@ -54,6 +54,7 @@
 	${PROJECT_SOURCE_DIR}/pv/prop/string.cpp
 	${PROJECT_SOURCE_DIR}/pv/popups/channels.cpp
 	${PROJECT_SOURCE_DIR}/pv/popups/deviceoptions.cpp
+	${PROJECT_SOURCE_DIR}/pv/subwindows/subwindowbase.cpp
 	${PROJECT_SOURCE_DIR}/pv/toolbars/mainbar.cpp
 	${PROJECT_SOURCE_DIR}/pv/views/trace/analogsignal.cpp
 	${PROJECT_SOURCE_DIR}/pv/views/trace/cursor.cpp
@@ -62,7 +63,6 @@
 	${PROJECT_SOURCE_DIR}/pv/views/trace/header.cpp
 	${PROJECT_SOURCE_DIR}/pv/views/trace/marginwidget.cpp
 	${PROJECT_SOURCE_DIR}/pv/views/trace/logicsignal.cpp
-	${PROJECT_SOURCE_DIR}/pv/views/trace/rowitem.cpp
 	${PROJECT_SOURCE_DIR}/pv/views/trace/ruler.cpp
 	${PROJECT_SOURCE_DIR}/pv/views/trace/signal.cpp
 	${PROJECT_SOURCE_DIR}/pv/views/trace/timeitem.cpp
@@ -85,6 +85,7 @@
 	${PROJECT_SOURCE_DIR}/pv/widgets/colorpopup.cpp
 	${PROJECT_SOURCE_DIR}/pv/widgets/devicetoolbutton.cpp
 	${PROJECT_SOURCE_DIR}/pv/widgets/exportmenu.cpp
+	${PROJECT_SOURCE_DIR}/pv/widgets/flowlayout.cpp
 	${PROJECT_SOURCE_DIR}/pv/widgets/importmenu.cpp
 	${PROJECT_SOURCE_DIR}/pv/widgets/popup.cpp
 	${PROJECT_SOURCE_DIR}/pv/widgets/popuptoolbutton.cpp
@@ -127,6 +128,7 @@
 	${PROJECT_SOURCE_DIR}/pv/prop/int.hpp
 	${PROJECT_SOURCE_DIR}/pv/prop/property.hpp
 	${PROJECT_SOURCE_DIR}/pv/prop/string.hpp
+	${PROJECT_SOURCE_DIR}/pv/subwindows/subwindowbase.hpp
 	${PROJECT_SOURCE_DIR}/pv/toolbars/mainbar.hpp
 	${PROJECT_SOURCE_DIR}/pv/views/trace/analogsignal.hpp
 	${PROJECT_SOURCE_DIR}/pv/views/trace/cursor.hpp
@@ -134,7 +136,6 @@
 	${PROJECT_SOURCE_DIR}/pv/views/trace/header.hpp
 	${PROJECT_SOURCE_DIR}/pv/views/trace/logicsignal.hpp
 	${PROJECT_SOURCE_DIR}/pv/views/trace/marginwidget.hpp
-	${PROJECT_SOURCE_DIR}/pv/views/trace/rowitem.hpp
 	${PROJECT_SOURCE_DIR}/pv/views/trace/ruler.hpp
 	${PROJECT_SOURCE_DIR}/pv/views/trace/signal.hpp
 	${PROJECT_SOURCE_DIR}/pv/views/trace/timeitem.hpp
@@ -153,6 +154,7 @@
 	${PROJECT_SOURCE_DIR}/pv/widgets/colorpopup.hpp
 	${PROJECT_SOURCE_DIR}/pv/widgets/devicetoolbutton.hpp
 	${PROJECT_SOURCE_DIR}/pv/widgets/exportmenu.hpp
+	${PROJECT_SOURCE_DIR}/pv/widgets/flowlayout.hpp
 	${PROJECT_SOURCE_DIR}/pv/widgets/importmenu.hpp
 	${PROJECT_SOURCE_DIR}/pv/widgets/popup.hpp
 	${PROJECT_SOURCE_DIR}/pv/widgets/popuptoolbutton.hpp
@@ -169,6 +171,11 @@
 		${PROJECT_SOURCE_DIR}/pv/data/decode/decoder.cpp
 		${PROJECT_SOURCE_DIR}/pv/data/decode/row.cpp
 		${PROJECT_SOURCE_DIR}/pv/data/decode/rowdata.cpp
+		${PROJECT_SOURCE_DIR}/pv/subwindows/decoder_selector/item.cpp
+		${PROJECT_SOURCE_DIR}/pv/subwindows/decoder_selector/model.cpp
+		${PROJECT_SOURCE_DIR}/pv/subwindows/decoder_selector/subwindow.cpp
+		${PROJECT_SOURCE_DIR}/pv/views/decoder_binary/view.cpp
+		${PROJECT_SOURCE_DIR}/pv/views/decoder_binary/QHexView.cpp
 		${PROJECT_SOURCE_DIR}/pv/views/trace/decodetrace.cpp
 		${PROJECT_SOURCE_DIR}/pv/widgets/decodergroupbox.cpp
 		${PROJECT_SOURCE_DIR}/pv/widgets/decodermenu.cpp
@@ -176,6 +183,9 @@
 
 	list(APPEND pulseview_TEST_HEADERS
 		${PROJECT_SOURCE_DIR}/pv/data/decodesignal.hpp
+		${PROJECT_SOURCE_DIR}/pv/subwindows/decoder_selector/subwindow.hpp
+		${PROJECT_SOURCE_DIR}/pv/views/decoder_binary/view.hpp
+		${PROJECT_SOURCE_DIR}/pv/views/decoder_binary/QHexView.hpp
 		${PROJECT_SOURCE_DIR}/pv/views/trace/decodetrace.hpp
 		${PROJECT_SOURCE_DIR}/pv/widgets/decodergroupbox.hpp
 		${PROJECT_SOURCE_DIR}/pv/widgets/decodermenu.hpp
