=== debian/changelog ===
pulseview (0.4.2-4) unstable; urgency=medium

  * Fix Build-Depends / Build-Depends-Arch up
  * Switch to pkgconf instead of pkg-config
  * Always use highest available C++ standard (Closes: #1110613)
  * Bump acceptable CMake version range (Closes: #1113428)
  * Bump debian/watch to v4
  * Bump Standards-Version to 4.7.2

 -- Jonathan McDowell <noodles@earth.li>  Sun, 28 Sep 2025 15:13:08 +0100

pulseview (0.4.2-3) unstable; urgency=medium

  * Apply upstream patch to fix use of template behind C linkage
    (Closes: #997286)

 -- Jonathan McDowell <noodles@earth.li>  Sun, 24 Oct 2021 13:40:30 +0100

pulseview (0.4.2-2) unstable; urgency=medium

  * Apply upstream patch to avoid obsolete QT methods (Closes: #976533)

 -- Jonathan McDowell <noodles@earth.li>  Sun, 06 Dec 2020 10:15:06 +0000

pulseview (0.4.2-1) unstable; urgency=medium

  * New upstream release.
    + Add build-dep on qttools5-dev.
    + Update debian/copyright.

 -- Jonathan McDowell <noodles@earth.li>  Tue, 21 Apr 2020 18:41:18 +0100
