=== debian/control ===
Source: pulseview
Section: electronics
Priority: optional
Maintainer: Debian Electronics Packaging Team <pkg-electronics-devel@alioth-lists.debian.net>
Uploaders: Jonathan McDowell <noodles@earth.li>
Build-Depends: debhelper (>= 10),
Build-Depends-Arch: cmake (>= 2.8.6),
	libboost-system-dev,
	libboost-thread-dev,
	libboost-filesystem-dev,
	libboost-test-dev,
	libglib2.0-dev (>= 2.28.0),
	libglibmm-2.4-dev (>= 2.28.0),
	libsigrokcxx-dev (>= 0.5.0),
	libsigrokdecode-dev (>= 0.5.0),
	libqt5svg5-dev,
	libsigc++-2.0-dev (>= 2.10.0-2.1),
	pkgconf,
	qtbase5-dev,
	qtbase5-dev-tools,
	qttools5-dev
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: http://sigrok.org/wiki/PulseView
Vcs-Browser: https://salsa.debian.org/electronics-team/sigrok/pulseview
Vcs-Git: https://salsa.debian.org/electronics-team/sigrok/pulseview.git

Package: pulseview
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: sigrok logic analyzer, oscilloscope, and MSO GUI
 PulseView is a GUI for sigrok that supports logic analyzers, oscilloscopes,
 and MSOs.
 .
 It can acquire samples from a supported device and display them,
 load and display captures from existing sigrok *.sr files, as well
 as run protocol decoders and display their annotations.
