=== debian/watch ===
version=4
https://sigrok.org/download/source/pulseview pulseview-(.*)\.tar\.gz
